diff --git a/gcc/config/rs6000/rs6000.c b/gcc/config/rs6000/rs6000.c
index 036a2af..14f8c18 100644
--- a/gcc/config/rs6000/rs6000.c
+++ b/gcc/config/rs6000/rs6000.c
@@ -1723,8 +1723,8 @@ rs6000_hard_regno_mode_ok (int regno, enum machine_mode mode)
      asked for it.  */
   if (TARGET_VSX && VSX_REGNO_P (regno)
       && (VECTOR_MEM_VSX_P (mode)
-	  || (TARGET_VSX_SCALAR_FLOAT && mode == SFmode)
-	  || (TARGET_VSX_SCALAR_DOUBLE && (mode == DFmode || mode == DImode))
+	  || (GCC_OPTION (TARGET_VSX_SCALAR_FLOAT) && mode == SFmode)
+	  || (GCC_OPTION (TARGET_VSX_SCALAR_DOUBLE) && (mode == DFmode || mode == DImode))
 	  || (TARGET_VSX_TIMODE && mode == TImode)
 	  || (TARGET_VADDUQM && mode == V1TImode)))
     {
@@ -2106,9 +2106,9 @@ rs6000_debug_reg_global (void)
   if (nl)
     fputs (nl, stderr);
 
-  if (rs6000_recip_control)
+  if (GCC_OPTION (rs6000_recip_control))
     {
-      fprintf (stderr, "\nReciprocal mask = 0x%x\n", rs6000_recip_control);
+      fprintf (stderr, "\nReciprocal mask = 0x%x\n", GCC_OPTION (rs6000_recip_control));
 
       for (m = 0; m < NUM_MACHINE_MODES; ++m)
 	if (rs6000_recip_bits[m])
@@ -2127,11 +2127,11 @@ rs6000_debug_reg_global (void)
       fputs ("\n", stderr);
     }
 
-  if (rs6000_cpu_index >= 0)
+  if (GCC_OPTION (rs6000_cpu_index) >= 0)
     {
-      const char *name = processor_target_table[rs6000_cpu_index].name;
+      const char *name = processor_target_table[GCC_OPTION (rs6000_cpu_index)].name;
       HOST_WIDE_INT flags
-	= processor_target_table[rs6000_cpu_index].target_enable;
+	= processor_target_table[GCC_OPTION (rs6000_cpu_index)].target_enable;
 
       sprintf (flags_buffer, "-mcpu=%s flags", name);
       rs6000_print_isa_options (stderr, 0, flags_buffer, flags);
@@ -2139,11 +2139,11 @@ rs6000_debug_reg_global (void)
   else
     fprintf (stderr, DEBUG_FMT_S, "cpu", "<none>");
 
-  if (rs6000_tune_index >= 0)
+  if (GCC_OPTION (rs6000_tune_index) >= 0)
     {
-      const char *name = processor_target_table[rs6000_tune_index].name;
+      const char *name = processor_target_table[GCC_OPTION (rs6000_tune_index)].name;
       HOST_WIDE_INT flags
-	= processor_target_table[rs6000_tune_index].target_enable;
+	= processor_target_table[GCC_OPTION (rs6000_tune_index)].target_enable;
 
       sprintf (flags_buffer, "-mtune=%s flags", name);
       rs6000_print_isa_options (stderr, 0, flags_buffer, flags);
@@ -2153,20 +2153,20 @@ rs6000_debug_reg_global (void)
 
   cl_target_option_save (&cl_opts, &global_options);
   rs6000_print_isa_options (stderr, 0, "rs6000_isa_flags",
-			    rs6000_isa_flags);
+			    GCC_OPTION (rs6000_isa_flags));
 
   rs6000_print_isa_options (stderr, 0, "rs6000_isa_flags_explicit",
-			    rs6000_isa_flags_explicit);
+			    GCC_OPTION (rs6000_isa_flags_explicit));
 
   rs6000_print_builtin_options (stderr, 0, "rs6000_builtin_mask",
-				rs6000_builtin_mask);
+				GCC_OPTION (rs6000_builtin_mask));
 
   rs6000_print_isa_options (stderr, 0, "TARGET_DEFAULT", TARGET_DEFAULT);
 
   fprintf (stderr, DEBUG_FMT_S, "--with-cpu default",
 	   OPTION_TARGET_CPU_DEFAULT ? OPTION_TARGET_CPU_DEFAULT : "<none>");
 
-  switch (rs6000_sched_costly_dep)
+  switch (GCC_OPTION (rs6000_sched_costly_dep))
     {
     case max_dep_latency:
       costly_str = "max_dep_latency";
@@ -2190,13 +2190,13 @@ rs6000_debug_reg_global (void)
 
     default:
       costly_str = costly_num;
-      sprintf (costly_num, "%d", (int)rs6000_sched_costly_dep);
+      sprintf (costly_num, "%d", (int)GCC_OPTION (rs6000_sched_costly_dep));
       break;
     }
 
   fprintf (stderr, DEBUG_FMT_S, "sched_costly_dep", costly_str);
 
-  switch (rs6000_sched_insert_nops)
+  switch (GCC_OPTION (rs6000_sched_insert_nops))
     {
     case sched_finish_regroup_exact:
       nop_str = "sched_finish_regroup_exact";
@@ -2212,13 +2212,13 @@ rs6000_debug_reg_global (void)
 
     default:
       nop_str = nop_num;
-      sprintf (nop_num, "%d", (int)rs6000_sched_insert_nops);
+      sprintf (nop_num, "%d", (int)GCC_OPTION (rs6000_sched_insert_nops));
       break;
     }
 
   fprintf (stderr, DEBUG_FMT_S, "sched_insert_nops", nop_str);
 
-  switch (rs6000_sdata)
+  switch (GCC_OPTION (rs6000_sdata))
     {
     default:
     case SDATA_NONE:
@@ -2238,7 +2238,7 @@ rs6000_debug_reg_global (void)
 
     }
 
-  switch (rs6000_traceback)
+  switch (GCC_OPTION (rs6000_traceback))
     {
     case traceback_default:	trace_str = "default";	break;
     case traceback_none:	trace_str = "none";	break;
@@ -2249,7 +2249,7 @@ rs6000_debug_reg_global (void)
 
   fprintf (stderr, DEBUG_FMT_S, "traceback", trace_str);
 
-  switch (rs6000_current_cmodel)
+  switch (GCC_OPTION (rs6000_current_cmodel))
     {
     case CMODEL_SMALL:	cmodel_str = "small";	break;
     case CMODEL_MEDIUM:	cmodel_str = "medium";	break;
@@ -2259,7 +2259,7 @@ rs6000_debug_reg_global (void)
 
   fprintf (stderr, DEBUG_FMT_S, "cmodel", cmodel_str);
 
-  switch (rs6000_current_abi)
+  switch (GCC_OPTION (rs6000_current_abi))
     {
     case ABI_NONE:	abi_str = "none";	break;
     case ABI_AIX:	abi_str = "aix";	break;
@@ -2271,16 +2271,16 @@ rs6000_debug_reg_global (void)
 
   fprintf (stderr, DEBUG_FMT_S, "abi", abi_str);
 
-  if (rs6000_altivec_abi)
+  if (GCC_OPTION (rs6000_altivec_abi))
     fprintf (stderr, DEBUG_FMT_S, "altivec_abi", "true");
 
-  if (rs6000_spe_abi)
+  if (GCC_OPTION (rs6000_spe_abi))
     fprintf (stderr, DEBUG_FMT_S, "spe_abi", "true");
 
-  if (rs6000_darwin64_abi)
+  if (GCC_OPTION (rs6000_darwin64_abi))
     fprintf (stderr, DEBUG_FMT_S, "darwin64_abi", "true");
 
-  if (rs6000_float_gprs)
+  if (GCC_OPTION (rs6000_float_gprs))
     fprintf (stderr, DEBUG_FMT_S, "float_gprs", "true");
 
   if (TARGET_LINK_STACK)
@@ -2296,16 +2296,16 @@ rs6000_debug_reg_global (void)
   fprintf (stderr, DEBUG_FMT_S, "plt-format",
 	   TARGET_SECURE_PLT ? "secure" : "bss");
   fprintf (stderr, DEBUG_FMT_S, "struct-return",
-	   aix_struct_return ? "aix" : "sysv");
-  fprintf (stderr, DEBUG_FMT_S, "always_hint", tf[!!rs6000_always_hint]);
-  fprintf (stderr, DEBUG_FMT_S, "sched_groups", tf[!!rs6000_sched_groups]);
+	   GCC_OPTION (aix_struct_return) ? "aix" : "sysv");
+  fprintf (stderr, DEBUG_FMT_S, "always_hint", tf[!!GCC_OPTION (rs6000_always_hint)]);
+  fprintf (stderr, DEBUG_FMT_S, "sched_groups", tf[!!GCC_OPTION (rs6000_sched_groups)]);
   fprintf (stderr, DEBUG_FMT_S, "align_branch",
-	   tf[!!rs6000_align_branch_targets]);
-  fprintf (stderr, DEBUG_FMT_D, "tls_size", rs6000_tls_size);
+	   tf[!!GCC_OPTION (rs6000_align_branch_targets)]);
+  fprintf (stderr, DEBUG_FMT_D, "tls_size", GCC_OPTION (rs6000_tls_size));
   fprintf (stderr, DEBUG_FMT_D, "long_double_size",
-	   rs6000_long_double_type_size);
+	   GCC_OPTION (rs6000_long_double_type_size));
   fprintf (stderr, DEBUG_FMT_D, "sched_restricted_insns_priority",
-	   (int)rs6000_sched_restricted_insns_priority);
+	   (int)GCC_OPTION (rs6000_sched_restricted_insns_priority));
   fprintf (stderr, DEBUG_FMT_D, "Number of standard builtins",
 	   (int)END_BUILTINS);
   fprintf (stderr, DEBUG_FMT_D, "Number of rs6000 builtins",
@@ -2491,7 +2491,7 @@ rs6000_init_hard_regno_mode_ok (bool global_init_p)
 
   /* The VSX hardware allows native alignment for vectors, but control whether the compiler
      believes it can use native alignment or still uses 128-bit alignment.  */
-  if (TARGET_VSX && !TARGET_VSX_ALIGN_128)
+  if (TARGET_VSX && !GCC_OPTION (TARGET_VSX_ALIGN_128))
     {
       align64 = 64;
       align32 = 32;
@@ -2565,7 +2565,7 @@ rs6000_init_hard_regno_mode_ok (bool global_init_p)
     }
 
   /* DFmode, see if we want to use the VSX unit.  */
-  if (TARGET_VSX && TARGET_VSX_SCALAR_DOUBLE)
+  if (TARGET_VSX && GCC_OPTION (TARGET_VSX_SCALAR_DOUBLE))
     {
       rs6000_vector_unit[DFmode] = VECTOR_VSX;
       rs6000_vector_mem[DFmode]
@@ -2850,46 +2850,46 @@ rs6000_init_hard_regno_mode_ok (bool global_init_p)
   if (VECTOR_UNIT_VSX_P (V2DFmode))
     rs6000_recip_bits[V2DFmode] |= RS6000_RECIP_MASK_HAVE_RSQRTE;
 
-  if (rs6000_recip_control)
+  if (GCC_OPTION (rs6000_recip_control))
     {
-      if (!flag_finite_math_only)
+      if (!GCC_OPTION (flag_finite_math_only))
 	warning (0, "-mrecip requires -ffinite-math or -ffast-math");
-      if (flag_trapping_math)
+      if (GCC_OPTION (flag_trapping_math))
 	warning (0, "-mrecip requires -fno-trapping-math or -ffast-math");
-      if (!flag_reciprocal_math)
+      if (!GCC_OPTION (flag_reciprocal_math))
 	warning (0, "-mrecip requires -freciprocal-math or -ffast-math");
-      if (flag_finite_math_only && !flag_trapping_math && flag_reciprocal_math)
+      if (GCC_OPTION (flag_finite_math_only) && !GCC_OPTION (flag_trapping_math) && GCC_OPTION (flag_reciprocal_math))
 	{
 	  if (RS6000_RECIP_HAVE_RE_P (SFmode)
-	      && (rs6000_recip_control & RECIP_SF_DIV) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_SF_DIV) != 0)
 	    rs6000_recip_bits[SFmode] |= RS6000_RECIP_MASK_AUTO_RE;
 
 	  if (RS6000_RECIP_HAVE_RE_P (DFmode)
-	      && (rs6000_recip_control & RECIP_DF_DIV) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_DF_DIV) != 0)
 	    rs6000_recip_bits[DFmode] |= RS6000_RECIP_MASK_AUTO_RE;
 
 	  if (RS6000_RECIP_HAVE_RE_P (V4SFmode)
-	      && (rs6000_recip_control & RECIP_V4SF_DIV) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_V4SF_DIV) != 0)
 	    rs6000_recip_bits[V4SFmode] |= RS6000_RECIP_MASK_AUTO_RE;
 
 	  if (RS6000_RECIP_HAVE_RE_P (V2DFmode)
-	      && (rs6000_recip_control & RECIP_V2DF_DIV) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_V2DF_DIV) != 0)
 	    rs6000_recip_bits[V2DFmode] |= RS6000_RECIP_MASK_AUTO_RE;
 
 	  if (RS6000_RECIP_HAVE_RSQRTE_P (SFmode)
-	      && (rs6000_recip_control & RECIP_SF_RSQRT) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_SF_RSQRT) != 0)
 	    rs6000_recip_bits[SFmode] |= RS6000_RECIP_MASK_AUTO_RSQRTE;
 
 	  if (RS6000_RECIP_HAVE_RSQRTE_P (DFmode)
-	      && (rs6000_recip_control & RECIP_DF_RSQRT) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_DF_RSQRT) != 0)
 	    rs6000_recip_bits[DFmode] |= RS6000_RECIP_MASK_AUTO_RSQRTE;
 
 	  if (RS6000_RECIP_HAVE_RSQRTE_P (V4SFmode)
-	      && (rs6000_recip_control & RECIP_V4SF_RSQRT) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_V4SF_RSQRT) != 0)
 	    rs6000_recip_bits[V4SFmode] |= RS6000_RECIP_MASK_AUTO_RSQRTE;
 
 	  if (RS6000_RECIP_HAVE_RSQRTE_P (V2DFmode)
-	      && (rs6000_recip_control & RECIP_V2DF_RSQRT) != 0)
+	      && (GCC_OPTION (rs6000_recip_control) & RECIP_V2DF_RSQRT) != 0)
 	    rs6000_recip_bits[V2DFmode] |= RS6000_RECIP_MASK_AUTO_RSQRTE;
 	}
     }
@@ -2946,42 +2946,42 @@ darwin_rs6000_override_options (void)
 {
   /* The Darwin ABI always includes AltiVec, can't be (validly) turned
      off.  */
-  rs6000_altivec_abi = 1;
-  TARGET_ALTIVEC_VRSAVE = 1;
-  rs6000_current_abi = ABI_DARWIN;
+  GCC_OPTION (rs6000_altivec_abi) = 1;
+  GCC_OPTION (TARGET_ALTIVEC_VRSAVE) = 1;
+  GCC_OPTION (rs6000_current_abi) = ABI_DARWIN;
 
   if (DEFAULT_ABI == ABI_DARWIN
       && TARGET_64BIT)
-      darwin_one_byte_bool = 1;
+      GCC_OPTION (darwin_one_byte_bool) = 1;
 
   if (TARGET_64BIT && ! TARGET_POWERPC64)
     {
-      rs6000_isa_flags |= OPTION_MASK_POWERPC64;
+      GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_POWERPC64;
       warning (0, "-m64 requires PowerPC64 architecture, enabling");
     }
-  if (flag_mkernel)
+  if (GCC_OPTION (flag_mkernel))
     {
-      rs6000_default_long_calls = 1;
-      rs6000_isa_flags |= OPTION_MASK_SOFT_FLOAT;
+      GCC_OPTION (rs6000_default_long_calls) = 1;
+      GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_SOFT_FLOAT;
     }
 
   /* Make -m64 imply -maltivec.  Darwin's 64-bit ABI includes
      Altivec.  */
-  if (!flag_mkernel && !flag_apple_kext
+  if (!GCC_OPTION (flag_mkernel) && !GCC_OPTION (flag_apple_kext)
       && TARGET_64BIT
-      && ! (rs6000_isa_flags_explicit & OPTION_MASK_ALTIVEC))
-    rs6000_isa_flags |= OPTION_MASK_ALTIVEC;
+      && ! (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_ALTIVEC))
+    GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_ALTIVEC;
 
   /* Unless the user (not the configurer) has explicitly overridden
      it with -mcpu=G3 or -mno-altivec, then 10.5+ targets default to
      G4 unless targeting the kernel.  */
-  if (!flag_mkernel
-      && !flag_apple_kext
-      && strverscmp (darwin_macosx_version_min, "10.5") >= 0
-      && ! (rs6000_isa_flags_explicit & OPTION_MASK_ALTIVEC)
+  if (!GCC_OPTION (flag_mkernel)
+      && !GCC_OPTION (flag_apple_kext)
+      && strverscmp (GCC_OPTION (darwin_macosx_version_min), "10.5") >= 0
+      && ! (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_ALTIVEC)
       && ! global_options_set.x_rs6000_cpu_index)
     {
-      rs6000_isa_flags |= OPTION_MASK_ALTIVEC;
+      GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_ALTIVEC;
     }
 }
 #endif
@@ -3010,7 +3010,7 @@ rs6000_builtin_mask_calculate (void)
 	  | ((TARGET_FRSQRTE)		    ? RS6000_BTM_FRSQRTE   : 0)
 	  | ((TARGET_FRSQRTES)		    ? RS6000_BTM_FRSQRTES  : 0)
 	  | ((TARGET_POPCNTD)		    ? RS6000_BTM_POPCNTD   : 0)
-	  | ((rs6000_cpu == PROCESSOR_CELL) ? RS6000_BTM_CELL      : 0)
+	  | ((GCC_OPTION (rs6000_cpu) == PROCESSOR_CELL) ? RS6000_BTM_CELL      : 0)
 	  | ((TARGET_P8_VECTOR)		    ? RS6000_BTM_P8_VECTOR : 0)
 	  | ((TARGET_CRYPTO)		    ? RS6000_BTM_CRYPTO	   : 0)
 	  | ((TARGET_HTM)		    ? RS6000_BTM_HTM	   : 0));
@@ -3037,14 +3037,14 @@ rs6000_option_override_internal (bool global_init_p)
 
   /* Remember the explicit arguments.  */
   if (global_init_p)
-    rs6000_isa_flags_explicit = global_options_set.x_rs6000_isa_flags;
+    GCC_OPTION (rs6000_isa_flags_explicit) = global_options_set.x_rs6000_isa_flags;
 
   /* On 64-bit Darwin, power alignment is ABI-incompatible with some C
      library functions, so warn about it. The flag may be useful for
      performance studies from time to time though, so don't disable it
      entirely.  */
   if (global_options_set.x_rs6000_alignment_flags
-      && rs6000_alignment_flags == MASK_ALIGN_POWER
+      && GCC_OPTION (rs6000_alignment_flags) == MASK_ALIGN_POWER
       && DEFAULT_ABI == ABI_DARWIN
       && TARGET_64BIT)
     warning (0, "-malign-power is not supported for 64-bit Darwin;"
@@ -3054,9 +3054,9 @@ rs6000_option_override_internal (bool global_init_p)
      calculation works better for RTL loop invariant motion on targets
      with enough (>= 32) registers.  It is an expensive optimization.
      So it is on only for peak performance.  */
-  if (optimize >= 3 && global_init_p
+  if (GCC_OPTION (optimize) >= 3 && global_init_p
       && !global_options_set.x_flag_ira_loop_pressure)
-    flag_ira_loop_pressure = 1;
+    GCC_OPTION (flag_ira_loop_pressure) = 1;
 
   /* Set the pointer size.  */
   if (TARGET_64BIT)
@@ -3087,32 +3087,32 @@ rs6000_option_override_internal (bool global_init_p)
 #endif
 
   /* Don't override by the processor default if given explicitly.  */
-  set_masks &= ~rs6000_isa_flags_explicit;
+  set_masks &= ~GCC_OPTION (rs6000_isa_flags_explicit);
 
   /* Process the -mcpu=<xxx> and -mtune=<xxx> argument.  If the user changed
      the cpu in a target attribute or pragma, but did not specify a tuning
      option, use the cpu for the tuning option rather than the option specified
      with -mtune on the command line.  Process a '--with-cpu' configuration
      request as an implicit --cpu.  */
-  if (rs6000_cpu_index >= 0)
+  if (GCC_OPTION (rs6000_cpu_index) >= 0)
     {
-      cpu_index = rs6000_cpu_index;
+      cpu_index = GCC_OPTION (rs6000_cpu_index);
       have_cpu = true;
     }
   else if (main_target_opt != NULL && main_target_opt->x_rs6000_cpu_index >= 0)
     {
-      rs6000_cpu_index = cpu_index = main_target_opt->x_rs6000_cpu_index;
+      GCC_OPTION (rs6000_cpu_index) = cpu_index = main_target_opt->x_rs6000_cpu_index;
       have_cpu = true;
     }
   else if (implicit_cpu)
     {
-      rs6000_cpu_index = cpu_index = rs6000_cpu_name_lookup (implicit_cpu);
+      GCC_OPTION (rs6000_cpu_index) = cpu_index = rs6000_cpu_name_lookup (implicit_cpu);
       have_cpu = true;
     }
   else
     {
       const char *default_cpu = (TARGET_POWERPC64 ? "powerpc64" : "powerpc");
-      rs6000_cpu_index = cpu_index = rs6000_cpu_name_lookup (default_cpu);
+      GCC_OPTION (rs6000_cpu_index) = cpu_index = rs6000_cpu_name_lookup (default_cpu);
       have_cpu = false;
     }
 
@@ -3125,25 +3125,25 @@ rs6000_option_override_internal (bool global_init_p)
      TARGET_DEFAULT.  */
   if (have_cpu)
     {
-      rs6000_isa_flags &= ~set_masks;
-      rs6000_isa_flags |= (processor_target_table[cpu_index].target_enable
+      GCC_OPTION (rs6000_isa_flags) &= ~set_masks;
+      GCC_OPTION (rs6000_isa_flags) |= (processor_target_table[cpu_index].target_enable
 			   & set_masks);
     }
   else
-    rs6000_isa_flags |= (processor_target_table[cpu_index].target_enable
-			 & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (processor_target_table[cpu_index].target_enable
+			 & ~GCC_OPTION (rs6000_isa_flags_explicit));
 
   /* If no -mcpu=<xxx>, inherit any default options that were cleared via
      POWERPC_MASKS.  Originally, TARGET_DEFAULT was used to initialize
      target_flags via the TARGET_DEFAULT_TARGET_FLAGS hook.  When we switched
      to using rs6000_isa_flags, we need to do the initialization here.  */
   if (!have_cpu)
-    rs6000_isa_flags |= (TARGET_DEFAULT & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (TARGET_DEFAULT & ~GCC_OPTION (rs6000_isa_flags_explicit));
 
-  if (rs6000_tune_index >= 0)
-    tune_index = rs6000_tune_index;
+  if (GCC_OPTION (rs6000_tune_index) >= 0)
+    tune_index = GCC_OPTION (rs6000_tune_index);
   else if (have_cpu)
-    rs6000_tune_index = tune_index = cpu_index;
+    GCC_OPTION (rs6000_tune_index) = tune_index = cpu_index;
   else
     {
       size_t i;
@@ -3154,60 +3154,60 @@ rs6000_option_override_internal (bool global_init_p)
       for (i = 0; i < ARRAY_SIZE (processor_target_table); i++)
 	if (processor_target_table[i].processor == tune_proc)
 	  {
-	    rs6000_tune_index = tune_index = i;
+	    GCC_OPTION (rs6000_tune_index) = tune_index = i;
 	    break;
 	  }
     }
 
   gcc_assert (tune_index >= 0);
-  rs6000_cpu = processor_target_table[tune_index].processor;
+  GCC_OPTION (rs6000_cpu) = processor_target_table[tune_index].processor;
 
   /* Pick defaults for SPE related control flags.  Do this early to make sure
      that the TARGET_ macros are representative ASAP.  */
   {
     int spe_capable_cpu =
-      (rs6000_cpu == PROCESSOR_PPC8540
-       || rs6000_cpu == PROCESSOR_PPC8548);
+      (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC8540
+       || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC8548);
 
     if (!global_options_set.x_rs6000_spe_abi)
-      rs6000_spe_abi = spe_capable_cpu;
+      GCC_OPTION (rs6000_spe_abi) = spe_capable_cpu;
 
     if (!global_options_set.x_rs6000_spe)
-      rs6000_spe = spe_capable_cpu;
+      GCC_OPTION (rs6000_spe) = spe_capable_cpu;
 
     if (!global_options_set.x_rs6000_float_gprs)
-      rs6000_float_gprs =
-        (rs6000_cpu == PROCESSOR_PPC8540 ? 1
-         : rs6000_cpu == PROCESSOR_PPC8548 ? 2
+      GCC_OPTION (rs6000_float_gprs) =
+        (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC8540 ? 1
+         : GCC_OPTION (rs6000_cpu) == PROCESSOR_PPC8548 ? 2
          : 0);
   }
 
   if (global_options_set.x_rs6000_spe_abi
-      && rs6000_spe_abi
+      && GCC_OPTION (rs6000_spe_abi)
       && !TARGET_SPE_ABI)
     error ("not configured for SPE ABI");
 
   if (global_options_set.x_rs6000_spe
-      && rs6000_spe
+      && GCC_OPTION (rs6000_spe)
       && !TARGET_SPE)
     error ("not configured for SPE instruction set");
 
   if (main_target_opt != NULL
-      && ((main_target_opt->x_rs6000_spe_abi != rs6000_spe_abi)
-          || (main_target_opt->x_rs6000_spe != rs6000_spe)
-          || (main_target_opt->x_rs6000_float_gprs != rs6000_float_gprs)))
+      && ((main_target_opt->x_rs6000_spe_abi != GCC_OPTION (rs6000_spe_abi))
+          || (main_target_opt->x_rs6000_spe != GCC_OPTION (rs6000_spe))
+          || (main_target_opt->x_rs6000_float_gprs != GCC_OPTION (rs6000_float_gprs))))
     error ("target attribute or pragma changes SPE ABI");
 
-  if (rs6000_cpu == PROCESSOR_PPCE300C2 || rs6000_cpu == PROCESSOR_PPCE300C3
-      || rs6000_cpu == PROCESSOR_PPCE500MC || rs6000_cpu == PROCESSOR_PPCE500MC64
-      || rs6000_cpu == PROCESSOR_PPCE5500)
+  if (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE300C2 || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE300C3
+      || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE500MC64
+      || GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE5500)
     {
       if (TARGET_ALTIVEC)
 	error ("AltiVec not supported in this target");
       if (TARGET_SPE)
 	error ("SPE not supported in this target");
     }
-  if (rs6000_cpu == PROCESSOR_PPCE6500)
+  if (GCC_OPTION (rs6000_cpu) == PROCESSOR_PPCE6500)
     {
       if (TARGET_SPE)
 	error ("SPE not supported in this target");
@@ -3215,15 +3215,15 @@ rs6000_option_override_internal (bool global_init_p)
 
   /* Disable Cell microcode if we are optimizing for the Cell
      and not optimizing for size.  */
-  if (rs6000_gen_cell_microcode == -1)
-    rs6000_gen_cell_microcode = !(rs6000_cpu == PROCESSOR_CELL
-                                  && !optimize_size);
+  if (GCC_OPTION (rs6000_gen_cell_microcode) == -1)
+    GCC_OPTION (rs6000_gen_cell_microcode) = !(GCC_OPTION (rs6000_cpu) == PROCESSOR_CELL
+                                  && !GCC_OPTION (optimize_size));
 
   /* If we are optimizing big endian systems for space and it's OK to
      use instructions that would be microcoded on the Cell, use the
      load/store multiple and string instructions.  */
-  if (BYTES_BIG_ENDIAN && optimize_size && rs6000_gen_cell_microcode)
-    rs6000_isa_flags |= ~rs6000_isa_flags_explicit & (OPTION_MASK_MULTIPLE
+  if (BYTES_BIG_ENDIAN && GCC_OPTION (optimize_size) && GCC_OPTION (rs6000_gen_cell_microcode))
+    GCC_OPTION (rs6000_isa_flags) |= ~GCC_OPTION (rs6000_isa_flags_explicit) & (OPTION_MASK_MULTIPLE
 						      | OPTION_MASK_STRING);
 
   /* Don't allow -mmultiple or -mstring on little endian systems
@@ -3232,19 +3232,19 @@ rs6000_option_override_internal (bool global_init_p)
      trap.  The 750 does not cause an alignment trap (except when the
      target is unaligned).  */
 
-  if (!BYTES_BIG_ENDIAN && rs6000_cpu != PROCESSOR_PPC750)
+  if (!BYTES_BIG_ENDIAN && GCC_OPTION (rs6000_cpu) != PROCESSOR_PPC750)
     {
       if (TARGET_MULTIPLE)
 	{
-	  rs6000_isa_flags &= ~OPTION_MASK_MULTIPLE;
-	  if ((rs6000_isa_flags_explicit & OPTION_MASK_MULTIPLE) != 0)
+	  GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_MULTIPLE;
+	  if ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_MULTIPLE) != 0)
 	    warning (0, "-mmultiple is not supported on little endian systems");
 	}
 
       if (TARGET_STRING)
 	{
-	  rs6000_isa_flags &= ~OPTION_MASK_STRING;
-	  if ((rs6000_isa_flags_explicit & OPTION_MASK_STRING) != 0)
+	  GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_STRING;
+	  if ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_STRING) != 0)
 	    warning (0, "-mstring is not supported on little endian systems");
 	}
     }
@@ -3253,18 +3253,18 @@ rs6000_option_override_internal (bool global_init_p)
      Testing for htm matches power8 and later.  */
   if (!BYTES_BIG_ENDIAN
       && !(processor_target_table[tune_index].target_enable & OPTION_MASK_HTM))
-    rs6000_isa_flags |= ~rs6000_isa_flags_explicit & OPTION_MASK_STRICT_ALIGN;
+    GCC_OPTION (rs6000_isa_flags) |= ~GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_STRICT_ALIGN;
 
   /* -maltivec={le,be} implies -maltivec.  */
-  if (rs6000_altivec_element_order != 0)
-    rs6000_isa_flags |= OPTION_MASK_ALTIVEC;
+  if (GCC_OPTION (rs6000_altivec_element_order) != 0)
+    GCC_OPTION (rs6000_isa_flags) |= OPTION_MASK_ALTIVEC;
 
   /* Disallow -maltivec=le in big endian mode for now.  This is not
      known to be useful for anyone.  */
-  if (BYTES_BIG_ENDIAN && rs6000_altivec_element_order == 1)
+  if (BYTES_BIG_ENDIAN && GCC_OPTION (rs6000_altivec_element_order) == 1)
     {
       warning (0, N_("-maltivec=le not allowed for big-endian targets"));
-      rs6000_altivec_element_order = 0;
+      GCC_OPTION (rs6000_altivec_element_order) = 0;
     }
 
   /* Add some warnings for VSX.  */
@@ -3274,22 +3274,22 @@ rs6000_option_override_internal (bool global_init_p)
       if (!TARGET_HARD_FLOAT || !TARGET_FPRS
 	  || !TARGET_SINGLE_FLOAT || !TARGET_DOUBLE_FLOAT)
 	{
-	  if (rs6000_isa_flags_explicit & OPTION_MASK_VSX)
+	  if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_VSX)
 	    msg = N_("-mvsx requires hardware floating point");
 	  else
 	    {
-	      rs6000_isa_flags &= ~ OPTION_MASK_VSX;
-	      rs6000_isa_flags_explicit |= OPTION_MASK_VSX;
+	      GCC_OPTION (rs6000_isa_flags) &= ~ OPTION_MASK_VSX;
+	      GCC_OPTION (rs6000_isa_flags_explicit) |= OPTION_MASK_VSX;
 	    }
 	}
       else if (TARGET_PAIRED_FLOAT)
 	msg = N_("-mvsx and -mpaired are incompatible");
-      else if (TARGET_AVOID_XFORM > 0)
+      else if (GCC_OPTION (TARGET_AVOID_XFORM) > 0)
 	msg = N_("-mvsx needs indexed addressing");
-      else if (!TARGET_ALTIVEC && (rs6000_isa_flags_explicit
+      else if (!TARGET_ALTIVEC && (GCC_OPTION (rs6000_isa_flags_explicit)
 				   & OPTION_MASK_ALTIVEC))
         {
-	  if (rs6000_isa_flags_explicit & OPTION_MASK_VSX)
+	  if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_VSX)
 	    msg = N_("-mvsx and -mno-altivec are incompatible");
 	  else
 	    msg = N_("-mno-altivec disables vsx");
@@ -3298,89 +3298,89 @@ rs6000_option_override_internal (bool global_init_p)
       if (msg)
 	{
 	  warning (0, msg);
-	  rs6000_isa_flags &= ~ OPTION_MASK_VSX;
-	  rs6000_isa_flags_explicit |= OPTION_MASK_VSX;
+	  GCC_OPTION (rs6000_isa_flags) &= ~ OPTION_MASK_VSX;
+	  GCC_OPTION (rs6000_isa_flags_explicit) |= OPTION_MASK_VSX;
 	}
     }
 
   /* If hard-float/altivec/vsx were explicitly turned off then don't allow
      the -mcpu setting to enable options that conflict. */
   if ((!TARGET_HARD_FLOAT || !TARGET_ALTIVEC || !TARGET_VSX)
-      && (rs6000_isa_flags_explicit & (OPTION_MASK_SOFT_FLOAT
+      && (GCC_OPTION (rs6000_isa_flags_explicit) & (OPTION_MASK_SOFT_FLOAT
 				       | OPTION_MASK_ALTIVEC
 				       | OPTION_MASK_VSX)) != 0)
-    rs6000_isa_flags &= ~((OPTION_MASK_P8_VECTOR | OPTION_MASK_CRYPTO
+    GCC_OPTION (rs6000_isa_flags) &= ~((OPTION_MASK_P8_VECTOR | OPTION_MASK_CRYPTO
 			   | OPTION_MASK_DIRECT_MOVE)
-		         & ~rs6000_isa_flags_explicit);
+		         & ~GCC_OPTION (rs6000_isa_flags_explicit));
 
   if (TARGET_DEBUG_REG || TARGET_DEBUG_TARGET)
-    rs6000_print_isa_options (stderr, 0, "before defaults", rs6000_isa_flags);
+    rs6000_print_isa_options (stderr, 0, "before defaults", GCC_OPTION (rs6000_isa_flags));
 
   /* For the newer switches (vsx, dfp, etc.) set some of the older options,
      unless the user explicitly used the -mno-<option> to disable the code.  */
   if (TARGET_P8_VECTOR || TARGET_DIRECT_MOVE || TARGET_CRYPTO)
-    rs6000_isa_flags |= (ISA_2_7_MASKS_SERVER & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_7_MASKS_SERVER & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_VSX)
-    rs6000_isa_flags |= (ISA_2_6_MASKS_SERVER & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_6_MASKS_SERVER & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_POPCNTD)
-    rs6000_isa_flags |= (ISA_2_6_MASKS_EMBEDDED & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_6_MASKS_EMBEDDED & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_DFP)
-    rs6000_isa_flags |= (ISA_2_5_MASKS_SERVER & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_5_MASKS_SERVER & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_CMPB)
-    rs6000_isa_flags |= (ISA_2_5_MASKS_EMBEDDED & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_5_MASKS_EMBEDDED & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_FPRND)
-    rs6000_isa_flags |= (ISA_2_4_MASKS & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_4_MASKS & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_POPCNTB)
-    rs6000_isa_flags |= (ISA_2_2_MASKS & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (ISA_2_2_MASKS & ~GCC_OPTION (rs6000_isa_flags_explicit));
   else if (TARGET_ALTIVEC)
-    rs6000_isa_flags |= (OPTION_MASK_PPC_GFXOPT & ~rs6000_isa_flags_explicit);
+    GCC_OPTION (rs6000_isa_flags) |= (OPTION_MASK_PPC_GFXOPT & ~GCC_OPTION (rs6000_isa_flags_explicit));
 
   if (TARGET_CRYPTO && !TARGET_ALTIVEC)
     {
-      if (rs6000_isa_flags_explicit & OPTION_MASK_CRYPTO)
+      if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_CRYPTO)
 	error ("-mcrypto requires -maltivec");
-      rs6000_isa_flags &= ~OPTION_MASK_CRYPTO;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_CRYPTO;
     }
 
   if (TARGET_DIRECT_MOVE && !TARGET_VSX)
     {
-      if (rs6000_isa_flags_explicit & OPTION_MASK_DIRECT_MOVE)
+      if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_DIRECT_MOVE)
 	error ("-mdirect-move requires -mvsx");
-      rs6000_isa_flags &= ~OPTION_MASK_DIRECT_MOVE;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_DIRECT_MOVE;
     }
 
   if (TARGET_P8_VECTOR && !TARGET_ALTIVEC)
     {
-      if (rs6000_isa_flags_explicit & OPTION_MASK_P8_VECTOR)
+      if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_P8_VECTOR)
 	error ("-mpower8-vector requires -maltivec");
-      rs6000_isa_flags &= ~OPTION_MASK_P8_VECTOR;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_P8_VECTOR;
     }
 
   if (TARGET_P8_VECTOR && !TARGET_VSX)
     {
-      if (rs6000_isa_flags_explicit & OPTION_MASK_P8_VECTOR)
+      if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_P8_VECTOR)
 	error ("-mpower8-vector requires -mvsx");
-      rs6000_isa_flags &= ~OPTION_MASK_P8_VECTOR;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_P8_VECTOR;
     }
 
   if (TARGET_VSX_TIMODE && !TARGET_VSX)
     {
-      if (rs6000_isa_flags_explicit & OPTION_MASK_VSX_TIMODE)
+      if (GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_VSX_TIMODE)
 	error ("-mvsx-timode requires -mvsx");
-      rs6000_isa_flags &= ~OPTION_MASK_VSX_TIMODE;
+      GCC_OPTION (rs6000_isa_flags) &= ~OPTION_MASK_VSX_TIMODE;
     }
 
   /* The quad memory instructions only works in 64-bit mode. In 32-bit mode,
      silently turn off quad memory mode.  */
   if ((TARGET_QUAD_MEMORY || TARGET_QUAD_MEMORY_ATOMIC) && !TARGET_POWERPC64)
     {
-      if ((rs6000_isa_flags_explicit & OPTION_MASK_QUAD_MEMORY) != 0)
+      if ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_QUAD_MEMORY) != 0)
 	warning (0, N_("-mquad-memory requires 64-bit mode"));
 
-      if ((rs6000_isa_flags_explicit & OPTION_MASK_QUAD_MEMORY_ATOMIC) != 0)
+      if ((GCC_OPTION (rs6000_isa_flags_explicit) & OPTION_MASK_QUAD_MEMORY_ATOMIC) != 0)
 	warning (0, N_("-mquad-memory-atomic requires 64-bit mode"));
 
-      rs6000_isa_flags &= ~(OPTION_MASK_QUAD_MEMORY
+      GCC_OPTION (rs6000_isa_flags) &= ~(OPTION_MASK_QUAD_MEMORY
 			    | OPTION_MASK_QUAD_MEMORY_ATOMIC);
     }
 
